import play.*;
import play.libs.Akka;
import static java.util.concurrent.TimeUnit.*;
import akka.util.*;
import models.Game;

public class Global extends GlobalSettings {

	private Game game;
	
	
	@Override
	public void onStart(Application app) {		
		Logger.info("Application has started");
		
		game = Game.getInstance();
		
		Akka.system().scheduler().schedule(
    	Duration.Zero(),
        Duration.create(10, SECONDS),
        	new Runnable() {
    			public void run() {
      				Logger.info("Calling GamingAPIClient");
      				game.addPlayers();
      				Logger.info("Got "+ game.getSize());
      				game.start_match();
    			}
  			}    	   	
		);
  	
  }  
  
  @Override
  public void onStop(Application app) {
    Logger.info("Application shutdown...");
  }
}