package controllers;

import java.util.List;
import java.util.Map;
import play.cache.Cache;
import models.*;
import play.*;
import play.mvc.*;
import views.html.*;
import play.data.DynamicForm;
import play.data.Form;


public class Application extends Controller {
	
	public static Result index() {
		//return ok( views.html.index.render() );
		return ok(index.render("Guess a number!",""));
	}
    
	public static Result game(String accessToken) {
		Game gm = Game.getInstance();
		Match myMatch = gm.getMatchForPlayer(accessToken);
		session("accessToken",accessToken);
		gm.start_match();
		
		if (myMatch != null) {
			
			if(myMatch.myTurn(accessToken)){
				if(myMatch.whoIsFirst().equals(accessToken)) {
					return ok(player1Page.render(myMatch.getPlayer(accessToken).getName(), "", myMatch ));
				} else {
					return ok(player1Page.render(myMatch.getPlayer(accessToken).getName(), Integer.toString(myMatch.getTries()-1), myMatch ));
				}
			} else {
				return ok(player2Wait.render());
			}
		} else {
			return ok(wait.render());
		}
	}
	
	public static Result input(){
		String aToken = session("accessToken");
		Game gm = Game.getInstance();
		Match myMatch = gm.getMatchForPlayer(aToken);
		Form<Guess> form = form(Guess.class).bindFromRequest();
		Guess guess1 = form.get();
		
		if( myMatch.inRange( guess1.getNumber() ) ) {
			myMatch.setNumber(guess1.getNumber(), aToken);
					
			if(  aToken.equals(myMatch.whoIsFirst()) ) {
				return ok( player1Wait.render() );
			} else {
				myMatch.checkWinner();
				System.out.println("Jugador:" + aToken + " con numero introducido: " + Integer.toString(guess1.getNumber()) + " intentos restantes: " + Integer.toString(myMatch.getTries()) + " ganador actual:" +  myMatch.whoWins() ); 
				if(myMatch.whoWins().equals(aToken)){				
					//session().clear();
					return ok(winner.render(aToken)); 
				}
				else {
					if( myMatch.getTries() == 0) {
						//session().clear();
						return ok(noWinner.render());
					} else {
						return ok(player1Page.render(myMatch.getPlayer(aToken).getName(), Integer.toString(myMatch.getTries()-1), myMatch ));
					}
				}
			}
		} else {
			return ok(player1Page.render(myMatch.getPlayer(aToken).getName(), Integer.toString(myMatch.getTries()-1), myMatch ));
		}
	}
	
	public static Result endGame(){
		String aToken = session("accessToken");
		Game gm = Game.getInstance();
		Match myMatch = gm.getMatchForPlayer(aToken);
		
		if(myMatch.myTurn(aToken)){
			if( myMatch.whoWins().equals(aToken) ) {
				//session().clear();
				gm.relocateWinner(aToken);
				return ok(winner.render(aToken));
			}
			else {
				//session().clear();
				//gm.relocateWinner(aToken);
				return ok(noWinner.render());
			}
		} else { 
			return ok( player1Wait.render() );
		}
	}
	
	public static Result cutRange(){
		String aToken = session("accessToken");
		Game gm = Game.getInstance();
		Match myMatch = gm.getMatchForPlayer(aToken);
		myMatch.cutRange();
		return ok(player1Page.render(myMatch.getPlayer(aToken).getName(), Integer.toString(myMatch.getTries()-1), myMatch ));
		
	}
	
	public static Result buy_cutRange(){
		String aToken = session("accessToken");
		Game gm = Game.getInstance();
		Match myMatch = gm.getMatchForPlayer(aToken);
		Form<Guess> form = form(Guess.class).bindFromRequest();
		Guess guess1 = form.get();
		myMatch.buyCut(guess1.getNumber());
		return ok(player1Page.render(myMatch.getPlayer(aToken).getName(), Integer.toString(myMatch.getTries()-1), myMatch ));	
	}
	
	public static Result halfRange(){
		String aToken = session("accessToken");
		Game gm = Game.getInstance();
		Match myMatch = gm.getMatchForPlayer(aToken);
		myMatch.halfRange();
		return ok(player1Page.render(myMatch.getPlayer(aToken).getName(), Integer.toString(myMatch.getTries()-1), myMatch ));
		
	}
	
	public static Result buy_halfRange(){
		String aToken = session("accessToken");
		Game gm = Game.getInstance();
		Match myMatch = gm.getMatchForPlayer(aToken);
		Form<Guess> form = form(Guess.class).bindFromRequest();
		Guess guess1 = form.get();
		myMatch.buyHalf(guess1.getNumber());
		return ok(player1Page.render(myMatch.getPlayer(aToken).getName(), Integer.toString(myMatch.getTries()-1), myMatch ));
	}
	
	
	public static Result quit(){
		String aToken = session("accessToken");
		Game gm = Game.getInstance();	
		session().clear();
		gm.quitGame(aToken);
		return ok();
	}
	
	
	public static Result admin(){
		Game gm = Game.getInstance();	
		return ok(admin.render());
	}
	
	
}
