package models;


public class Players implements Comparable<Players> {

	private String 	Name;
	private String	avatar_url;
	private String	atoken;
	private int 	tries;
	private int 	win_count;
	private int 	guess_number;
	private int 	num_cut_range;
	private int 	num_half_range;
	private boolean	isFirst;
	private boolean myTurn;
	private boolean	winner;
	
	
	
	/*
	 * @param string name and String Acces_token
	 * constructor of the class player set the name and id and set to 0 the wins counter*/
	public Players(String name, String access_token, boolean first, boolean winner, boolean turn){
		this.Name = name;
		this.setAtoken(access_token);
		this.win_count = 0;
		this.myTurn = turn;
		this.isFirst = first;
		this.tries = 5;
		this.winner = winner;
		this.num_cut_range = 0;
		this.num_half_range = 0;
	}
	
	/**@return boolean result of buy half the range*/
	public boolean useHalf(){
		if((this.num_half_range - 1) >= 0){
			this.num_half_range--;
			return true;
		} else { return false; }
	}
	 /**@param amount of new half*/
	public void buyHalf(int amount){
		this.num_half_range += amount;
	}
	
	/**@param amount of new cut the range*/
	public void buyCut(int amount){
		this.num_cut_range += amount;
	}
	
	/**@return boolean result of buy cut the range*/
	public boolean useCut(){
		if((this.num_cut_range - 1) >= 0){
			this.num_cut_range--;
			return true;
		} else { return false; }
	}
	
	/**@param value of the num cut*/
	public void setNumCut(int value){
		this.num_cut_range = value;
	}
	
	/**@param value of the num half*/
	public void setNumHalf(int value){
		this.num_half_range = value;
	}
	
	/**
	 * reset the tries parameter */
	public void setTries(){
		this.tries = 6;
	}
	
	/**
	 * @return the tries
	 */
	public int getTries() {
		return tries;
	}

	/**
	 * Decrease 1 the try counter*/
	public void decreaseTry(){
		this.tries = this.tries - 1;
	}

	/**
	 * @return return if is the user's turn
	 */
	public boolean isMyTurn() {
		return myTurn;
	}

	/**
	 * @param set the user turn
	 */
	public void setMyTurn(boolean turn) {
		this.myTurn = turn;
	}

	/*
	 * @param String name
	 * Set the player name*/
	public void setName(String name){
		this.Name = name;
	}
	
	/*
	 * @param integer number
	 * set the number that the player has entered to play (the number to guess)*/
	public void setNumber(int number){
		this.guess_number = number;
	}
	
	/*
	 * Reset the wins counter*/
	public void reset_wins(){
		this.win_count = 0;
	}
	
	/**@param integer wins*/
	public void setWins(int wins){
		this.win_count=wins;
	}
	
	/*
	 * Add one to the wins counter*/
	public void add_win(){
		this.win_count++;
	}
	/*
	 * get the secret number of the player*/
	public int getNumber(){
		return this.guess_number;
	}
	
	/*
	 * get the players name*/
	public String getName(){
		return this.Name;
	}
		
	/*
	 * @return the number of wins
	 * get the number of wins in a row of the player*/
	public int getWins(){
		return this.win_count;
	}
	
	/**
	 * @return the access token
	 */
	public String getAtoken() {
		return atoken;
	}

	/**
	 * @param access token to set
	 */
	public void setAtoken(String atoken) {
		this.atoken = atoken;
	}
	
	/**
	 * @return the number of cut the range the user has
	 */
	public int getNum_cut_range() {
		return this.num_cut_range;
	}

	/**
	 * @param set the number of cut the range the user has
	 */
	public void setNum_cut_range(int num_cut_range) {
		this.num_cut_range = num_cut_range;
	}

	/**
	 * @return the number of half range the user has
	 */
	public int getNum_half_range() {
		return num_half_range;
	}

	/**
	 * @param set the number of half range the user has
	 */
	public void setNum_half_range(int num_half_range) {
		this.num_half_range = num_half_range;
	}
		
			
	/*
	 * basic constructor, just set to 0 the wins counter*/
	public Players(){
		this.win_count = 0;
	}
	
	/*
	 * @return 1 if two players introduce and guess the same number or 0 if not*/
	public int compareTo(Players e){
		if (this.guess_number == e.getNumber())
			return 1;
		else
			return 0;
	}

	/**
	 * @return the isFirst
	 */
	public boolean isFirst() {
		return isFirst;
	}

	/**
	 * @param isFirst the isFirst to set
	 */
	public void setFirst(boolean isFirst) {
		this.isFirst = isFirst;
	}

	/**
	 * @return the winner
	 */
	public boolean isWinner() {
		return winner;
	}

	/**
	 * @param winner the winner to set
	 */
	public void setWinner(boolean winner) {
		this.winner = winner;
	}

	/**
	 * @return the avatar_url
	 */
	public String getAvatar_url() {
		return avatar_url;
	}

	/**
	 * @param avatar_url the avatar_url to set
	 */
	public void setAvatar_url(String avatar_url) {
		this.avatar_url = avatar_url;
	}
		

}//End of class Players

